#!/usr/local/bin/perl -w
use strict;
use IO::File;

my $addressbook = "addressbook";
my $book = new IO::File $addressbook or
   die "Cannot open $addressbook\n";
my @addresses = ();
my ($name, $address, $lastname);
while (<$book>) {
   chomp;
   ($name, $address) = split /:/;
   ($lastname = $name) =~ s/.*\s//;
   push(@addresses, {
      lastname => $lastname,
      name => $name,
      address => $address
   });
}
$book->close;

foreach $address (sort byLastName @addresses) {
   printf "%-25s | %s\n",
      $address->{name}, $address->{address};
}

sub byLastName { $a->{lastname} cmp $b ->{lastname} }
